#pragma config WDT = OFF
#pragma config OSC = ECIO
#pragma config PWRT = ON
#pragma config BOR = OFF
#pragma config LVP = OFF
#pragma config DEBUG = ON
#pragma config STVR = OFF

#include "can18xx8.h"
#include <p18F458.h>
#include <stdio.h>
#include <usart.h>


// Variablen CAN Empfang

unsigned long Message_ID = 0xC0;       // Welche ID soll aus dem Empfangspuffer genommen werden
BYTE NewMessageData[8];    
BYTE NewMessageLen;
enum CAN_RX_MSG_FLAGS NewMessageFlags;
unsigned int temp;
int winkel;


void main(void) {

long unsigned int i;
char Ausgabe[20];


// CAN Modul initialisieren mit 500 kHz , 8 Tq @ 16 MHz PIC Takt
	// BRP      = 0
	// PROPSEG  = 1 [Tq]
	// PHSEG1   = 8 [Tq]
	// PHSEG2   = 8 [Tq]
	// SJW      = 1 [Tq]
	// SamplePoint bei 62,5%

CANInitialize (1, 1, 8, 8, 8, 
			   CAN_CONFIG_VALID_STD_MSG);

CANSetOperationModeNoWait (CAN_OP_MODE_NORMAL);  // <- Mit CAN_OP_MODE_LISTEN 
												 // klappt das lesen aber sonst nicht.



// 9600 Baud

OpenUSART(  USART_TX_INT_OFF &
			USART_RX_INT_OFF &
			USART_ASYNCH_MODE &
			USART_EIGHT_BIT &
			USART_CONT_RX &
			USART_BRGH_HIGH,
			162 );


	putrsUSART ("\x1b\x59\x20\x20\x1b\x4a");
	putrsUSART ("\x1b\x59\x20\x21                  *** CAN - Testprogramm Lenkrad Kalibrierung ***");
  
while(1) {

if (CANIsRxPassive()) putrsUSART ("\x1b\x59\x24\x21 CAN ist RX passive !");
if (CANIsTxPassive()) putrsUSART ("\x1b\x59\x25\x21 CAN ist TX passive !");

sprintf (Ausgabe, "\x1b\x59\x26\x21 Fehler RX -> %d     ", CANGetRxErrorCount() );
putsUSART (Ausgabe);

    if ( CANIsRxReady() ) {
		

		 if	(CANReceiveMessage (&Message_ID,
							   NewMessageData,
							   &NewMessageLen,
							   &NewMessageFlags) ) {
			
		


			if (NewMessageFlags & CAN_RX_OVERFLOW) putsUSART ("\x1b\x59\x27\x21 RX OVERFLOW ! ");
			if (NewMessageFlags & CAN_RX_XTD_FRAME) putsUSART ("\x1b\x59\x28\x21 XTD FRAME ! ");
			if (NewMessageFlags & CAN_RX_INVALID_MSG) putsUSART ("\x1b\x59\x29\x21 Invalid FRAME ! ");
			if (NewMessageFlags & CAN_RX_RTR_FRAME) putsUSART ("\x1b\x59\x29\x21 RTR FRAME ! ");


			winkel = NewMessageData[1];
			winkel = winkel << 8;
			winkel = winkel + NewMessageData[0];
			
	if (winkel > 10) putrsUSART ("\x1b\x59\x24\x21 Nach Links  drehen !");
			if (winkel < -10) putrsUSART ("\x1b\x59\x24\x21 Nach Rechts drehen !");
			if ( (winkel >= -10) && (winkel <= 10)) putrsUSART ("\x1b\x59\x24\x21 Perfekt !               ");

			sprintf (Ausgabe, "\x1b\x59\x21\x21 -> %d ", winkel );
			putsUSART (Ausgabe);

		
			}

	}




  }

}

